using System;
using System.Collections;
using System.Diagnostics;

namespace AutomataPattern
{
	public class State
	{
		protected Automata _automata = null;
		protected ArrayList _actionContainer = null;
		protected ArrayList _automataContainer = null;

		public State( Automata au ) 
		{
			_automata = au; 
			_actionContainer = new ArrayList();
			_automataContainer = new ArrayList();
		}

		public void AddAction( Action action )
		{
			_actionContainer.Add( action );
		}

		public void ClearActionContainer()
		{
			_actionContainer.Clear();
		}

		public void AddAutomata( Automata au )
		{
			_automataContainer.Add( au );
		}

		public void ClearAutomataContainer()
		{
			_automataContainer.Clear();
		}

		public virtual void Execute( int e )
		{
			foreach ( Automata a in _automataContainer )
				a.Execute( e );
		}

		public virtual void ExecuteIn()
		{
			foreach ( Action a in _actionContainer )
				a.Do();
		}
		
		public virtual void Log()
		{
			Trace.WriteLine(String.Format("* Entering state: {0}", GetType().ToString()), "State entry");						
		}
	}	
}